## Requirements
This manual assumes You're familiar at least with the following: 
* AWS
* K8s
* terraform & terragrunt
* helm & helmfile, helm secrets (sops)
* Gitlab CI

## Client Software Requirements:
* MacOS or Linux. Windows supports all the tools but is out of scope of this manual
* git
* [terraform](https://www.terraform.io/downloads.html) 0.12, 0.13 isn't tested
* [terragrunt](https://github.com/gruntwork-io/terragrunt#install-terragrunt)
* [kubectl](https://kubernetes.io/docs/tasks/tools/install-kubectl/) 
* [helm](https://helm.sh/docs/using_helm/#installing-helm), version 3
* [helmfile](https://github.com/roboll/helmfile#installation) 
* [helm-secrets](https://github.com/zendesk/helm-secrets#installation-and-dependencies) plugin

## Top-level road-map: 
* create aws account, configure aws cli with your keys
* clone this repo, configure terraform remote state storage, create/adjust terragrunt manifests
* provision AWS services and EKS cluster via terragrunt
* configure CI/CD, build Docker image
* create/adjust helmfile values 
* deploy internal services into EKS via helmfile
* create helm-operator CRD to deploy user services via fluxcd and dedicated git repo
* check 
* teardown

## Notes
There is a lot of things that can be implemented in different/more optimal/more secure/generic way. We didn't 
focused on perfect implementation in this manual.  Some(not all) known issues:
- CI/CD deploy may be implemented via helm/helmfile as well instead of kubectl
- database migration files are copied from `tenant-registry` project to this repo into chart body. 
It's better to "bake" these files into docker image and use files from docker image during database migration.
- Gitlab CI/CD is provided with whole cluster "edit" privileges. Least privileges should be used. 
- terraform state S3 user has `AmazonS3FullAccess` to all S3 buckets. It should be a separate bucket with versioning 
enabled and located in separate account w/o removal possibility from terraform side.
- teardown doesn't include resources, which are deployed by fluxcd/helm-operator 

At the same time there is some sort of initial overhead used to provide encryption to store all sensitive data securely in the repository
to follow gitops patterns. 
## Open questions
* it may be better to use in-cluster state for fluxcd instead of git repo tags with multi-tenancy
* we need to distinguish tenants settings to provide specific configuration and secrets. This can be implemented in 
different ways, here are some:
    * use unique git branch and/or directory per tenant and configure tenant's fluxcd to use it
    * move all the unique and secret settings out of fluxcd control and use other tools to provision/maintain it
* we need to get fluxcd private ssh key from every tenant to get ssh public key and add it into gitlab repo deploy keys.
    It doesn't fit into "pull" model. Fluxcd allows to specify pre-created k8s secret with ssh private key instead of 
    autogenerated key, thus it may be pre-created by terraform/helmfile and added to gitlab [via api](https://docs.gitlab.com/ee/api/deploy_keys.html#add-deploy-key)
    or [terraform provider](https://www.terraform.io/docs/providers/gitlab/r/deploy_key.html) w/o manual action
* helm-operator we've used to deploy `tenant-registry`, [doesn't support sops natively](https://github.com/fluxcd/helm-operator/issues/184),
  official recommended solution is to use [SealedSecrets](https://github.com/fluxcd/helm-operator-get-started#managing-kubernetes-secrets),
  but it splits deployment into multiple parts instead of single helm release:
    * helm-operator deploys helm chart w/o secrets
    * fluxcd deploys `SealedSecret` (with correct name into correct namespace) as a separate k8s resource, and then 
    `Sealed Secrets Controller` generates k8s `Secret` with decrypted data
    
  Taking into account this is a PoC, we've used a workaround - entire `HelmRelease` CRD is encrypted with sops using AWS
  KMS key. Fluxcd supports sops decryption, it downloads and decrypts CRD manifest, applies it to k8s and then 
  helm-operator gets all the values and secrets to proceed with helm release. This solution is hard to maintain.
  Other possible options include:
   * terraform/helmfile generation of fluxcd/k8s resources
   * helm chart adaptation to work with multiple secrets and so on
   * use [external secrets](https://github.com/godaddy/kubernetes-external-secrets) with cloud secret managers/storages 
   and populate it with some internal tools 
   
  In short - "it depends".   
* fluxcd image poller is useless with helm releases, as fluxcd applies changes to automated workloads(raw k8s manifests) which are deployed via
 fluxcd git repo only. It doesn't affect arbitrary k8s controllers, which is k8s `Deployment` by helm & helm-operator in our case.
 One of possible options to implement "pull" update is to use unique image tags(such as git commit_id based or semver) 
 during docker image build and then update image tag in the corresponding `HelmRelease` CRD. helm-operator [supports](https://docs.fluxcd.io/projects/helm-operator/en/stable/helmrelease-guide/values/#values-from-sources)
 values merging from different sources including external source. Thus we may use external source to specify chart's 
 `image.tag` to perform "centralized update with single change".              
## Main part

* Create aws account, complete AWS IAM Dashboard Security Status
* Configure aws-cli with your account access and secret keys via `aws configure`
* Clone this repo and change dir to repo root dir 
    ```bash
    git clone https://gitlab.com/dysnix/t0/whispli/deploy.git
    cd deploy
    export PROJECT_ROOT=$(pwd)
    ```
* Create aws S3 bucket, f.e `w-tf-state` and specify it's name and region in `$PROJECT_ROOT/grunt/terragrunt.hcl`
* Create aws IAM user `tf-s3` with `AmazonS3FullAccess` policy and `Programmatic access` 
* Save access key and secret key of user `tf-s3` into `$PROJECT_ROOT/grunt/secrets.yaml`
* Create aws KMS key aliased `tf` with use access from your user account
* Specify KMS key `tf`'s ARN in `$PROJECT_ROOT/.sops.yaml` under `grunt/secrets` section
* Run `sops -e -i $PROJECT_ROOT/grunt/secrets.yaml` to encrypt `secrets.yaml`
* Adjust `$PROJECT_ROOT/grunt/dev/infra/terragrunt.hcl`. Point attention to 
    * region
    * cluster_name, cluster_version
    * instance type
    * database name & username
* Now we should be ready to run terragrunt. Let's start with `plan` 
    ```bash
    cd $PROJECT_ROOT/grunt/dev/infra
    terragrunt plan
    ```
    Please review carefully all the proposed resources terraform is going to create for You. If You're ok with it - go ahead
    using following command:
    ```bash
    cd $PROJECT_ROOT/grunt/dev/infra
    terragrunt apply
    ```
    Type `yes` to confirm changes. It should take 10-20 minutes to provision resources. 
* Grab terragrunt output to generate/update ~/.kube/config to connect to EKS cluster, use `whispli-dev` as k8s context name.
Check k8s connection via 
    ```bash
    export KUBE_CONTEXT=whispli-dev
    kubectl --context $KUBE_CONTEXT cluster-info
    ```
    You shouldn't see any errors.
* Generate k8s service account to allow gitlab-ci to access k8s
    ```bash
    # Service account
    kubectl --context $KUBE_CONTEXT -n default apply -f - <<EOF
    apiVersion: v1
    kind: ServiceAccount
    metadata:
      name: gitlab-ci
    EOF
    # Service account secret
    kubectl --context $KUBE_CONTEXT -n default apply -f - <<EOF
    apiVersion: v1
    kind: Secret
    metadata:
      name: gitlab-ci-secret
      annotations:
        kubernetes.io/service-account.name: gitlab-ci
    type: kubernetes.io/service-account-token
    EOF
    # Service account cluster role binding
    kubectl --context $KUBE_CONTEXT create clusterrolebinding gitlab-ci-binding --clusterrole edit --serviceaccount=default:gitlab-ci
    ```
* Create Giltab CI/CD environment variables for `tenant-registry` Gitlab project via `Settings -> CI/CD -> Variables`:
    * add `DEV_KUBE_TOKEN` with value
        ```bash
        kubectl --context $KUBE_CONTEXT -n default get secret gitlab-ci-secret -o jsonpath="{.data.token}"|base64 --decode;echo ""
        ```
    * add `DEV_KUBE_URL` with **URL** value of `kubectl --context $KUBE_CONTEXT cluster-info` line related to `Kubernetes master`
* Adjust `.gitlab-ci.yml` in `tenant-registry` Gitlab project when required. Push Your changes to run the pipeline or 
create the pipeline manually in case of no changes. `Build` step should finish w/o issues. 
We got Docker image of `tenant-registry` in Gitlab container registry.
*  Create a Gitlab [deploy token](https://docs.gitlab.com/ce/user/project/deploy_tokens/index.html#creating-a-deploy-token) with 
  `read_registry` permission
* Create k8s secret `gitlab-registry` to permit EKS cluster to access Gitlab container registry using username and token
    from previous step
    ```bash
    kubectl --context $KUBE_CONTEXT create ns dev flux
    kubectl --context $KUBE_CONTEXT -n dev create secret docker-registry --docker-username=<USERNAME> --docker-password=<TOKEN> --docker-server=registry.gitlab.com gitlab-registry
    kubectl --context $KUBE_CONTEXT -n flux create secret docker-registry --docker-username=<USERNAME> --docker-password=<TOKEN> --docker-server=registry.gitlab.com gitlab-registry
    ```
* Create an empty git repository `flux` to use as fluxcd "source-of-truth" 
* Configure fluxcd - specify git url,branch,path and label in `$PROJECT_ROOT/deploy/dev/values-flux.yaml.gotmpl`
* Let's deploy our internal services:
    ```bash
    cd $PROJECT_ROOT/deploy
    helmfile -e dev sync
    ``` 
  This command will deploy `nginx-ingress`, `cert-manager`, `fluxcd` and `helm-operator` to the EKS cluster using helm.
  It's time to adjust DNS settings to point your base domain to address of `nginx-ingress` load balancer. You may get it
   from the following command output:
   ```bash
    kubectl --context $KUBE_CONTEXT -n ingress get svc -o wide
   ```
* Add fluxcd ssh public key to `flux` gitlab repo deploy keys with write access
    * get fluxcd ssh private key
        ```bash
        kubectl --context $KUBE_CONTEXT -n flux get secret flux-git-deploy -o jsonpath="{.data.identity}"|base64 --decode > flux_rsa
        ``` 
    * get ssh public key from ssh private key
        ```bash
        chmod 400 flux_rsa
        ssh-keygen -y -f flux_rsa
        rm -f flux_rsa
        ```     
    * Visit `Settings->Repository->Deploy Keys` of `flux` repository and add ssh public key with write access
    
  Now ouf fluxcd instance is configured to poll updates from `flux` git repo and it has gitlab permissions to access 
  this repo.
* Generate CRD `HelmRelease` manifest for helm-operator to deploy our services ( tenant-registry in our case ) and save 
  this manifest into `flux` repo, use `c0/releases/tenant-registry.yaml` as a file name.
  You need to specify all the values and secrets that your service requires in the `tenant-registry.yaml`. Use existing 
  file as a template(you may need to decrypt it with `sops -d`).
  
  We use `helm` KMS key to encrypt `tenant-registry.yaml` with sops, thus you need to: 
  * specify this KMS key ARN in `flux` repo in `c0/.sops.yaml` file
  * grant EKS worker nodes role to use `helm` KMS key
  
  Encrypt `c0/releases/tenant-registry.yaml` with the following command:
  ```bash
  cd c0
  sops -e -i releases/tenant-registry.yaml 
  ```
  Add all files under `c0` directory in `flux` repo into commit and push changes.
  
  In a couple minutes You should get `tenant-registry` up and running
* Let's check our service f.e via https://r1.whispli.dysnix.org:
    ```bash
    curl https://r1.whispli.dysnix.org
    {"message":"not found","errors":[{"path":"/","message":"not found"}]}
    ``` 
  Service is up and responding. 
* Teardown is relatively simple:
    ```bash
    cd $PROJECT_ROOT/deploy
    helmfile -e dev destroy
    cd $PROJECT_ROOT/grunt/dev/infra
    terragrunt destroy
    ```
    Type `yes` to confirm teardown. It should take a couple minutes. 
    Don't forget to remove terraform state bucket and KMS keys we've created during this manual 
